    001/* ========================================================================
    002 * JCommon : a free general purpose class library for the Java(tm) platform
    003 * ========================================================================
    004 *
    005 * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jcommon/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025 * in the United States and other countries.]
    026 *
    027 * ------------------
    028 * JTextObserver.java
    029 * ------------------
    030 * (C) Copyright 2004, by Thomas Morgner and Contributors.
    031 *
    032 * Original Author:  Thomas Morgner;
    033 * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034 *
    035 * $Id: JTextObserver.java,v 1.6 2007/11/02 17:50:36 taqua Exp $
    036 *
    037 * Changes
    038 * -------
    039 * 07-Jun-2004 : Added JCommon header (DG);
    040 *
    041 */
    042
    043package org.jfree.ui;
    044
    045import java.awt.event.FocusEvent;
    046import java.awt.event.FocusListener;
    047import javax.swing.text.JTextComponent;
    048
    049/**
    050 * An observer that selects all the text when a field gains the focus.
    051 *
    052 * @author Thomas Morgner
    053 */
    054public final class JTextObserver implements FocusListener {
    055
    056    /** The singleton instance. */
    057    private static JTextObserver singleton;
    058
    059    /**
    060     * Creates a new instance.
    061     */
    062    private JTextObserver() {
    063        // nothing required
    064    }
    065
    066    /**
    067     * Returns the single instance.
    068     *
    069     * @return The single instance.
    070     */
    071    public static JTextObserver getInstance() {
    072        if (singleton == null) {
    073           singleton = new JTextObserver();
    074        }
    075        return singleton;
    076    }
    077
    078    /**
    079     * Selects all the text when a field gains the focus.
    080     *
    081     * @param e  the focus event.
    082     */
    083    public void focusGained(final FocusEvent e) {
    084        if (e.getSource() instanceof JTextComponent) {
    085            final JTextComponent tex = (JTextComponent) e.getSource();
    086            tex.selectAll();
    087        }
    088    }
    089
    090    /**
    091     * Deselects the text when a field loses the focus.
    092     *
    093     * @param e  the event.
    094     */
    095    public void focusLost(final FocusEvent e) {
    096        if (e.getSource() instanceof JTextComponent) {
    097            final JTextComponent tex = (JTextComponent) e.getSource();
    098            tex.select(0, 0);
    099        }
    100    }
    101
    102    /**
    103     * Adds this instance as a listener for the specified text component.
    104     *
    105     * @param t  the text component.
    106     */
    107    public static void addTextComponent(final JTextComponent t) {
    108        if (singleton == null) {
    109            singleton = new JTextObserver();
    110        }
    111        t.addFocusListener(singleton);
    112    }
    113
    114    /**
    115     * Removes this instance as a listener for the specified text component.
    116     *
    117     * @param t  the text component.
    118     */
    119   public static void removeTextComponent(final JTextComponent t) {
    120        if (singleton == null) {
    121            singleton = new JTextObserver();
    122        }
    123        t.removeFocusListener(singleton);
    124    }
    125
    126}